VTK: vtkHigherOrderInterpolation Class Reference

| VTK 9.0.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkHigherOrderInterpolation Class Referenceabstract

`#include <vtkHigherOrderInterpolation.h>`

Inheritance diagram for vtkHigherOrderInterpolation:
[legend]
Collaboration diagram for vtkHigherOrderInterpolation:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkHigherOrderInterpolation * | NewInstance () const
virtual void | Tensor3EvaluateDerivative (const int order[3], const double *pcoords, vtkPoints *points, const double *fieldVals, int fieldDim, double *fieldDerivs)=0
void | Tensor3EvaluateDerivative (const int order[3], const double *pcoords, vtkPoints *points, const double *fieldVals, int fieldDim, double *fieldDerivs, void(*function_evaluate_shape_and_gradient)(int, double, double *, double *))
int | JacobianInverse (vtkPoints *points, const double *derivs, double **inverse)
| Compute the inverse of the Jacobian and put the values in `inverse`. More...
int | JacobianInverseWedge (vtkPoints *points, const double *derivs, double **inverse)
virtual void | WedgeEvaluate (const int order[3], const vtkIdType numberOfPoints, const double *pcoords, double *fieldVals, int fieldDim, double *fieldAtPCoords)=0
void | WedgeEvaluate (const int order[3], const vtkIdType numberOfPoints, const double *pcoords, double *fieldVals, int fieldDim, double *fieldAtPCoords, vtkHigherOrderTriangle &tri, void(*function_evaluate_shape_functions)(int, double, double *))
virtual void | WedgeEvaluateDerivative (const int order[3], const double *pcoords, vtkPoints *points, const double *fieldVals, int fieldDim, double *fieldDerivs)=0
void | WedgeEvaluateDerivative (const int order[3], const double *pcoords, vtkPoints *points, const double *fieldVals, int fieldDim, double *fieldDerivs, vtkHigherOrderTriangle &tri, void(*function_evaluate_shape_and_gradient)(int, double, double *, double *))
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
vtkCommand * | GetCommand (unsigned long tag)
void | RemoveObserver (vtkCommand *)
void | RemoveObservers (unsigned long event, vtkCommand *)
void | RemoveObservers (const char *event, vtkCommand *)
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
int | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
int | InvokeEvent (const char *event, void *callData)
int | InvokeEvent (unsigned long event)
int | InvokeEvent (const char *event)
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
void | PrintRevisions (ostream &)
| Legacy. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkHigherOrderInterpolation * | SafeDownCast (vtkObjectBase *o)
static int | Tensor1ShapeFunctions (const int order[1], const double *pcoords, double *shape, void(*function_evaluate_shape_functions)(int, double, double *))
static int | Tensor1ShapeDerivatives (const int order[1], const double *pcoords, double *derivs, void(*function_evaluate_shape_and_gradient)(int, double, double *, double *))
static int | Tensor2ShapeFunctions (const int order[2], const double *pcoords, double *shape, void(*function_evaluate_shape_functions)(int, double, double *))
static int | Tensor2ShapeDerivatives (const int order[2], const double *pcoords, double *derivs, void(*function_evaluate_shape_and_gradient)(int, double, double *, double *))
static int | Tensor3ShapeFunctions (const int order[3], const double *pcoords, double *shape, void(*function_evaluate_shape_functions)(int, double, double *))
static int | Tensor3ShapeDerivatives (const int order[3], const double *pcoords, double *derivs, void(*function_evaluate_shape_and_gradient)(int, double, double *, double *))
static void | WedgeShapeFunctions (const int order[3], const vtkIdType numberOfPoints, const double *pcoords, double *shape, vtkHigherOrderTriangle &tri, void(*function_evaluate_shape_functions)(int, double, double *))
static void | WedgeShapeDerivatives (const int order[3], const vtkIdType numberOfPoints, const double *pcoords, double *derivs, vtkHigherOrderTriangle &tri, void(*function_evaluate_shape_and_gradient)(int, double, double *, double *))
static vtkVector3d | GetParametricHexCoordinates (int vertexId)
static vtkVector2i | GetPointIndicesBoundingHexEdge (int edgeId)
static int | GetVaryingParameterOfHexEdge (int edgeId)
static vtkVector2i | GetFixedParametersOfHexEdge (int edgeId)
static const int * | GetPointIndicesBoundingHexFace (int faceId)
static const int * | GetEdgeIndicesBoundingHexFace (int faceId)
static vtkVector2i | GetVaryingParametersOfHexFace (int faceId)
static int | GetFixedParameterOfHexFace (int faceId)
static vtkVector3d | GetParametricWedgeCoordinates (int vertexId)
static vtkVector2i | GetPointIndicesBoundingWedgeEdge (int edgeId)
static int | GetVaryingParameterOfWedgeEdge (int edgeId)
static vtkVector2i | GetFixedParametersOfWedgeEdge (int edgeId)
static const int * | GetPointIndicesBoundingWedgeFace (int faceId)
static const int * | GetEdgeIndicesBoundingWedgeFace (int faceId)
static vtkVector2i | GetVaryingParametersOfWedgeFace (int faceId)
static int | GetFixedParameterOfWedgeFace (int faceId)
static void | AppendCurveCollocationPoints (vtkSmartPointer< vtkPoints > &pts, const int order[1])
static void | AppendQuadrilateralCollocationPoints (vtkSmartPointer< vtkPoints > &pts, const int order[2])
static void | AppendHexahedronCollocationPoints (vtkSmartPointer< vtkPoints > &pts, const int order[3])
static void | AppendWedgeCollocationPoints (vtkSmartPointer< vtkPoints > &pts, const int order[3])
template<int N>
static int | NumberOfIntervals (const int order[N])
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (int val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
static void | GlobalWarningDisplayOff ()
static int | GetGlobalWarningDisplay ()
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkHigherOrderInterpolation ()
| ~vtkHigherOrderInterpolation () override
void | PrepareForOrder (const int order[3], const vtkIdType numberOfPoints)
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | CollectRevisions (ostream &)
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
std::vector< double > | ShapeSpace
std::vector< double > | DerivSpace
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

Definition at line 35 of file vtkHigherOrderInterpolation.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkHigherOrderInterpolation::Superclass

Definition at line 40 of file vtkHigherOrderInterpolation.h.

## Constructor & Destructor Documentation

## ◆ vtkHigherOrderInterpolation()

vtkHigherOrderInterpolation::vtkHigherOrderInterpolation | ( |  | ) |
| protected

## ◆ ~vtkHigherOrderInterpolation()

vtkHigherOrderInterpolation::~vtkHigherOrderInterpolation | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ PrintSelf()

void vtkHigherOrderInterpolation::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

Reimplemented in vtkLagrangeInterpolation.

## ◆ IsTypeOf()

static vtkTypeBool vtkHigherOrderInterpolation::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkHigherOrderInterpolation::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

Reimplemented in vtkBezierInterpolation, and vtkLagrangeInterpolation.

## ◆ SafeDownCast()

static vtkHigherOrderInterpolation* vtkHigherOrderInterpolation::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkHigherOrderInterpolation::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented in vtkBezierInterpolation, and vtkLagrangeInterpolation.

## ◆ NewInstance()

vtkHigherOrderInterpolation* vtkHigherOrderInterpolation::NewInstance | ( |  | ) | const

## ◆ Tensor1ShapeFunctions()

static int vtkHigherOrderInterpolation::Tensor1ShapeFunctions | ( | const int | order[1],
|  | const double * | pcoords,
|  | double * | shape,
|  | void(*)(int, double, double *) | function_evaluate_shape_functions
| ) |  |
| static

## ◆ Tensor1ShapeDerivatives()

static int vtkHigherOrderInterpolation::Tensor1ShapeDerivatives | ( | const int | order[1],
|  | const double * | pcoords,
|  | double * | derivs,
|  | void(*)(int, double, double *, double *) | function_evaluate_shape_and_gradient
| ) |  |
| static

## ◆ Tensor2ShapeFunctions()

static int vtkHigherOrderInterpolation::Tensor2ShapeFunctions | ( | const int | order[2],
|  | const double * | pcoords,
|  | double * | shape,
|  | void(*)(int, double, double *) | function_evaluate_shape_functions
| ) |  |
| static

## ◆ Tensor2ShapeDerivatives()

static int vtkHigherOrderInterpolation::Tensor2ShapeDerivatives | ( | const int | order[2],
|  | const double * | pcoords,
|  | double * | derivs,
|  | void(*)(int, double, double *, double *) | function_evaluate_shape_and_gradient
| ) |  |
| static

## ◆ Tensor3ShapeFunctions()

static int vtkHigherOrderInterpolation::Tensor3ShapeFunctions | ( | const int | order[3],
|  | const double * | pcoords,
|  | double * | shape,
|  | void(*)(int, double, double *) | function_evaluate_shape_functions
| ) |  |
| static

## ◆ Tensor3ShapeDerivatives()

static int vtkHigherOrderInterpolation::Tensor3ShapeDerivatives | ( | const int | order[3],
|  | const double * | pcoords,
|  | double * | derivs,
|  | void(*)(int, double, double *, double *) | function_evaluate_shape_and_gradient
| ) |  |
| static

## ◆ Tensor3EvaluateDerivative() [1/2]

virtual void vtkHigherOrderInterpolation::Tensor3EvaluateDerivative | ( | const int | order[3],
|  | const double * | pcoords,
|  | vtkPoints * | points,
|  | const double * | fieldVals,
|  | int | fieldDim,
|  | double * | fieldDerivs
| ) |  |
| pure virtual

Implemented in vtkBezierInterpolation, and vtkLagrangeInterpolation.

## ◆ Tensor3EvaluateDerivative() [2/2]

void vtkHigherOrderInterpolation::Tensor3EvaluateDerivative | ( | const int | order[3],
|  | const double * | pcoords,
|  | vtkPoints * | points,
|  | const double * | fieldVals,
|  | int | fieldDim,
|  | double * | fieldDerivs,
|  | void(*)(int, double, double *, double *) | function_evaluate_shape_and_gradient
| ) |  |

## ◆ WedgeShapeFunctions()

static void vtkHigherOrderInterpolation::WedgeShapeFunctions | ( | const int | order[3],
|  | const vtkIdType | numberOfPoints,
|  | const double * | pcoords,
|  | double * | shape,
|  | vtkHigherOrderTriangle & | tri,
|  | void(*)(int, double, double *) | function_evaluate_shape_functions
| ) |  |
| static

## ◆ WedgeShapeDerivatives()

static void vtkHigherOrderInterpolation::WedgeShapeDerivatives | ( | const int | order[3],
|  | const vtkIdType | numberOfPoints,
|  | const double * | pcoords,
|  | double * | derivs,
|  | vtkHigherOrderTriangle & | tri,
|  | void(*)(int, double, double *, double *) | function_evaluate_shape_and_gradient
| ) |  |
| static

## ◆ JacobianInverse()

int vtkHigherOrderInterpolation::JacobianInverse | ( | vtkPoints * | points,
|  | const double * | derivs,
|  | double ** | inverse
| ) |  |

Compute the inverse of the Jacobian and put the values in `inverse`.

Returns 1 for success and 0 for failure (i.e. couldn't invert the Jacobian).

## ◆ JacobianInverseWedge()

int vtkHigherOrderInterpolation::JacobianInverseWedge | ( | vtkPoints * | points,
|  | const double * | derivs,
|  | double ** | inverse
| ) |  |

## ◆ WedgeEvaluate() [1/2]

virtual void vtkHigherOrderInterpolation::WedgeEvaluate | ( | const int | order[3],
|  | const vtkIdType | numberOfPoints,
|  | const double * | pcoords,
|  | double * | fieldVals,
|  | int | fieldDim,
|  | double * | fieldAtPCoords
| ) |  |
| pure virtual

Implemented in vtkBezierInterpolation, and vtkLagrangeInterpolation.

## ◆ WedgeEvaluate() [2/2]

void vtkHigherOrderInterpolation::WedgeEvaluate | ( | const int | order[3],
|  | const vtkIdType | numberOfPoints,
|  | const double * | pcoords,
|  | double * | fieldVals,
|  | int | fieldDim,
|  | double * | fieldAtPCoords,
|  | vtkHigherOrderTriangle & | tri,
|  | void(*)(int, double, double *) | function_evaluate_shape_functions
| ) |  |

## ◆ WedgeEvaluateDerivative() [1/2]

virtual void vtkHigherOrderInterpolation::WedgeEvaluateDerivative | ( | const int | order[3],
|  | const double * | pcoords,
|  | vtkPoints * | points,
|  | const double * | fieldVals,
|  | int | fieldDim,
|  | double * | fieldDerivs
| ) |  |
| pure virtual

Implemented in vtkBezierInterpolation, and vtkLagrangeInterpolation.

## ◆ WedgeEvaluateDerivative() [2/2]

void vtkHigherOrderInterpolation::WedgeEvaluateDerivative | ( | const int | order[3],
|  | const double * | pcoords,
|  | vtkPoints * | points,
|  | const double * | fieldVals,
|  | int | fieldDim,
|  | double * | fieldDerivs,
|  | vtkHigherOrderTriangle & | tri,
|  | void(*)(int, double, double *, double *) | function_evaluate_shape_and_gradient
| ) |  |

## ◆ GetParametricHexCoordinates()

static vtkVector3d vtkHigherOrderInterpolation::GetParametricHexCoordinates | ( | int | vertexId | ) |
| static

## ◆ GetPointIndicesBoundingHexEdge()

static vtkVector2i vtkHigherOrderInterpolation::GetPointIndicesBoundingHexEdge | ( | int | edgeId | ) |
| static

## ◆ GetVaryingParameterOfHexEdge()

static int vtkHigherOrderInterpolation::GetVaryingParameterOfHexEdge | ( | int | edgeId | ) |
| static

## ◆ GetFixedParametersOfHexEdge()

static vtkVector2i vtkHigherOrderInterpolation::GetFixedParametersOfHexEdge | ( | int | edgeId | ) |
| static

## ◆ GetPointIndicesBoundingHexFace()

static const int* vtkHigherOrderInterpolation::GetPointIndicesBoundingHexFace | ( | int | faceId | ) |
| static

## ◆ GetEdgeIndicesBoundingHexFace()

static const int* vtkHigherOrderInterpolation::GetEdgeIndicesBoundingHexFace | ( | int | faceId | ) |
| static

## ◆ GetVaryingParametersOfHexFace()

static vtkVector2i vtkHigherOrderInterpolation::GetVaryingParametersOfHexFace | ( | int | faceId | ) |
| static

## ◆ GetFixedParameterOfHexFace()

static int vtkHigherOrderInterpolation::GetFixedParameterOfHexFace | ( | int | faceId | ) |
| static

## ◆ GetParametricWedgeCoordinates()

static vtkVector3d vtkHigherOrderInterpolation::GetParametricWedgeCoordinates | ( | int | vertexId | ) |
| static

## ◆ GetPointIndicesBoundingWedgeEdge()

static vtkVector2i vtkHigherOrderInterpolation::GetPointIndicesBoundingWedgeEdge | ( | int | edgeId | ) |
| static

## ◆ GetVaryingParameterOfWedgeEdge()

static int vtkHigherOrderInterpolation::GetVaryingParameterOfWedgeEdge | ( | int | edgeId | ) |
| static

## ◆ GetFixedParametersOfWedgeEdge()

static vtkVector2i vtkHigherOrderInterpolation::GetFixedParametersOfWedgeEdge | ( | int | edgeId | ) |
| static

## ◆ GetPointIndicesBoundingWedgeFace()

static const int* vtkHigherOrderInterpolation::GetPointIndicesBoundingWedgeFace | ( | int | faceId | ) |
| static

## ◆ GetEdgeIndicesBoundingWedgeFace()

static const int* vtkHigherOrderInterpolation::GetEdgeIndicesBoundingWedgeFace | ( | int | faceId | ) |
| static

## ◆ GetVaryingParametersOfWedgeFace()

static vtkVector2i vtkHigherOrderInterpolation::GetVaryingParametersOfWedgeFace | ( | int | faceId | ) |
| static

## ◆ GetFixedParameterOfWedgeFace()

static int vtkHigherOrderInterpolation::GetFixedParameterOfWedgeFace | ( | int | faceId | ) |
| static

## ◆ AppendCurveCollocationPoints()

static void vtkHigherOrderInterpolation::AppendCurveCollocationPoints | ( | vtkSmartPointer< vtkPoints > & | pts,
|  | const int | order[1]
| ) |  |
| static

## ◆ AppendQuadrilateralCollocationPoints()

static void vtkHigherOrderInterpolation::AppendQuadrilateralCollocationPoints | ( | vtkSmartPointer< vtkPoints > & | pts,
|  | const int | order[2]
| ) |  |
| static

## ◆ AppendHexahedronCollocationPoints()

static void vtkHigherOrderInterpolation::AppendHexahedronCollocationPoints | ( | vtkSmartPointer< vtkPoints > & | pts,
|  | const int | order[3]
| ) |  |
| static

## ◆ AppendWedgeCollocationPoints()

static void vtkHigherOrderInterpolation::AppendWedgeCollocationPoints | ( | vtkSmartPointer< vtkPoints > & | pts,
|  | const int | order[3]
| ) |  |
| static

## ◆ NumberOfIntervals()

template<int N>

int vtkHigherOrderInterpolation::NumberOfIntervals | ( | const int | order[N] | ) |
| static

Definition at line 137 of file vtkHigherOrderInterpolation.h.

## ◆ PrepareForOrder()

void vtkHigherOrderInterpolation::PrepareForOrder | ( | const int | order[3],
|  | const vtkIdType | numberOfPoints
| ) |  |
| protected

## Member Data Documentation

## ◆ ShapeSpace

std::vector<double> vtkHigherOrderInterpolation::ShapeSpace
| protected

Definition at line 128 of file vtkHigherOrderInterpolation.h.

## ◆ DerivSpace

std::vector<double> vtkHigherOrderInterpolation::DerivSpace
| protected

Definition at line 129 of file vtkHigherOrderInterpolation.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkHigherOrderInterpolation.h